VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CWindowsThread"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Dim hThread As Long, hThreadID As Long
Dim mThreadParent As Object
Dim mThreadObject As IWinThread
Dim mthread_begining As Boolean
Public Event Complete()

Public Sub Thread__()
Attribute Thread__.VB_MemberFlags = "40"
    'MsgBox "Procedure begin Thread__..."
    'MsgBox "Before begin..."
    mThreadObject.Begin
    'RaiseEvent Complete
    hThreadID = 0
    mthread_begining = False
    ExitThread 0
End Sub

Public Sub Begin()
    If mthread_begining Then Err.Raise -15, , "Thread already run": Exit Sub
    mthread_begining = True
    Dim hAddr As Long, hAddr2 As Long
    hAddr2 = GetCWinThreadPtr(Me)
    CopyMemory hAddr, ByVal hAddr2, 4
    hAddr = hAddr + 28
    CopyMemory hAddr, ByVal hAddr, 4
'    MsgBox "Before CreateThread..."
    Set mThreadObject.Parent = mThreadParent
    Set mThreadObject.ThreadContext = Me
    hThread = CreateThread(ByVal 0&, 0&, hAddr, hAddr2, CREATE_NEW, hThreadID)
    CloseHandle hThread
End Sub

Public Property Set ThreadParent(ByVal NewVal As Object)
    If Not mthread_begining Then
        Set mThreadParent = NewVal
    Else
        Err.Raise -15, , "Thread already run"
    End If
End Property
Public Property Get ThreadParent() As Object
    Set ThreadParent = mThreadParent
End Property

Public Property Set ThreadObject(ByVal NewVal As IWinThread)
    If Not mthread_begining Then
        Set mThreadObject = NewVal
    Else
        Err.Raise -15, , "Thread already run"
    End If
End Property
Public Property Get ThreadObject() As IWinThread
    Set ThreadObject = mThreadObject
End Property

Private Sub Class_Terminate()
If mthread_begining Then
    Terminate
End If
End Sub

Public Sub Terminate()
If Not mthread_begining Then Err.Raise -15, , "Thread not run": Exit Sub
Dim hExitCode As Long
GetExitCodeThread hThreadID, hExitCode
TerminateThread hThreadID, hExitCode
End Sub

Public Property Get IsRun() As Boolean
    IsRun = mthread_begining
End Property
